
rm(list=ls(all=TRUE))
# set working directory with setwd()

phi1 <- seq(-0.8,0.8,0.2)
phi2 <- phi1

# read selection frequencies of DGPs with varying persistence parameters

dat.m08m08 <- read.table("freq.AR.TAR.1000.TAR(1,1),-08-08.xls",sep = '\t')
dat.m06m08 <- read.table("freq.AR.TAR.1000.TAR(1,1),-06-08.xls",sep = '\t')
dat.m04m08 <- read.table("freq.AR.TAR.1000.TAR(1,1),-04-08.xls",sep = '\t')
dat.m02m08 <- read.table("freq.AR.TAR.1000.TAR(1,1),-02-08.xls",sep = '\t')
dat.p00m08 <- read.table("freq.AR.TAR.1000.TAR(1,1),+00-08.xls",sep = '\t')
dat.p02m08 <- read.table("freq.AR.TAR.1000.TAR(1,1),+02-08.xls",sep = '\t')
dat.p04m08 <- read.table("freq.AR.TAR.1000.TAR(1,1),+04-08.xls",sep = '\t')
dat.p06m08 <- read.table("freq.AR.TAR.1000.TAR(1,1),+06-08.xls",sep = '\t')
dat.p08m08 <- read.table("freq.AR.TAR.1000.TAR(1,1),+08-08.xls",sep = '\t')

dat.m08m06 <- read.table("freq.AR.TAR.1000.TAR(1,1),-08-06.xls",sep = '\t')
dat.m06m06 <- read.table("freq.AR.TAR.1000.TAR(1,1),-06-06.xls",sep = '\t')
dat.m04m06 <- read.table("freq.AR.TAR.1000.TAR(1,1),-04-06.xls",sep = '\t')
dat.m02m06 <- read.table("freq.AR.TAR.1000.TAR(1,1),-02-06.xls",sep = '\t')
dat.p00m06 <- read.table("freq.AR.TAR.1000.TAR(1,1),+00-06.xls",sep = '\t')
dat.p02m06 <- read.table("freq.AR.TAR.1000.TAR(1,1),+02-06.xls",sep = '\t')
dat.p04m06 <- read.table("freq.AR.TAR.1000.TAR(1,1),+04-06.xls",sep = '\t')
dat.p06m06 <- read.table("freq.AR.TAR.1000.TAR(1,1),+06-06.xls",sep = '\t')
dat.p08m06 <- read.table("freq.AR.TAR.1000.TAR(1,1),+08-06.xls",sep = '\t')

dat.m08m04 <- read.table("freq.AR.TAR.1000.TAR(1,1),-08-04.xls",sep = '\t')
dat.m06m04 <- read.table("freq.AR.TAR.1000.TAR(1,1),-06-04.xls",sep = '\t')
dat.m04m04 <- read.table("freq.AR.TAR.1000.TAR(1,1),-04-04.xls",sep = '\t')
dat.m02m04 <- read.table("freq.AR.TAR.1000.TAR(1,1),-02-04.xls",sep = '\t')
dat.p00m04 <- read.table("freq.AR.TAR.1000.TAR(1,1),+00-04.xls",sep = '\t')
dat.p02m04 <- read.table("freq.AR.TAR.1000.TAR(1,1),+02-04.xls",sep = '\t')
dat.p04m04 <- read.table("freq.AR.TAR.1000.TAR(1,1),+04-04.xls",sep = '\t')
dat.p06m04 <- read.table("freq.AR.TAR.1000.TAR(1,1),+06-04.xls",sep = '\t')
dat.p08m04 <- read.table("freq.AR.TAR.1000.TAR(1,1),+08-04.xls",sep = '\t')

dat.m08m02 <- read.table("freq.AR.TAR.1000.TAR(1,1),-08-02.xls",sep = '\t')
dat.m06m02 <- read.table("freq.AR.TAR.1000.TAR(1,1),-06-02.xls",sep = '\t')
dat.m04m02 <- read.table("freq.AR.TAR.1000.TAR(1,1),-04-02.xls",sep = '\t')
dat.m02m02 <- read.table("freq.AR.TAR.1000.TAR(1,1),-02-02.xls",sep = '\t')
dat.p00m02 <- read.table("freq.AR.TAR.1000.TAR(1,1),+00-02.xls",sep = '\t')
dat.p02m02 <- read.table("freq.AR.TAR.1000.TAR(1,1),+02-02.xls",sep = '\t')
dat.p04m02 <- read.table("freq.AR.TAR.1000.TAR(1,1),+04-02.xls",sep = '\t')
dat.p06m02 <- read.table("freq.AR.TAR.1000.TAR(1,1),+06-02.xls",sep = '\t')
dat.p08m02 <- read.table("freq.AR.TAR.1000.TAR(1,1),+08-02.xls",sep = '\t')

dat.m08p00 <- read.table("freq.AR.TAR.1000.TAR(1,1),-08+00.xls",sep = '\t')
dat.m06p00 <- read.table("freq.AR.TAR.1000.TAR(1,1),-06+00.xls",sep = '\t')
dat.m04p00 <- read.table("freq.AR.TAR.1000.TAR(1,1),-04+00.xls",sep = '\t')
dat.m02p00 <- read.table("freq.AR.TAR.1000.TAR(1,1),-02+00.xls",sep = '\t')
dat.p00p00 <- read.table("freq.AR.TAR.1000.TAR(1,1),+00+00.xls",sep = '\t')
dat.p02p00 <- read.table("freq.AR.TAR.1000.TAR(1,1),+02+00.xls",sep = '\t')
dat.p04p00 <- read.table("freq.AR.TAR.1000.TAR(1,1),+04+00.xls",sep = '\t')
dat.p06p00 <- read.table("freq.AR.TAR.1000.TAR(1,1),+06+00.xls",sep = '\t')
dat.p08p00 <- read.table("freq.AR.TAR.1000.TAR(1,1),+08+00.xls",sep = '\t')

dat.m08p02 <- read.table("freq.AR.TAR.1000.TAR(1,1),-08+02.xls",sep = '\t')
dat.m06p02 <- read.table("freq.AR.TAR.1000.TAR(1,1),-06+02.xls",sep = '\t')
dat.m04p02 <- read.table("freq.AR.TAR.1000.TAR(1,1),-04+02.xls",sep = '\t')
dat.m02p02 <- read.table("freq.AR.TAR.1000.TAR(1,1),-02+02.xls",sep = '\t')
dat.p00p02 <- read.table("freq.AR.TAR.1000.TAR(1,1),+00+02.xls",sep = '\t')
dat.p02p02 <- read.table("freq.AR.TAR.1000.TAR(1,1),+02+02.xls",sep = '\t')
dat.p04p02 <- read.table("freq.AR.TAR.1000.TAR(1,1),+04+02.xls",sep = '\t')
dat.p06p02 <- read.table("freq.AR.TAR.1000.TAR(1,1),+06+02.xls",sep = '\t')
dat.p08p02 <- read.table("freq.AR.TAR.1000.TAR(1,1),+08+02.xls",sep = '\t')

dat.m08p04 <- read.table("freq.AR.TAR.1000.TAR(1,1),-08+04.xls",sep = '\t')
dat.m06p04 <- read.table("freq.AR.TAR.1000.TAR(1,1),-06+04.xls",sep = '\t')
dat.m04p04 <- read.table("freq.AR.TAR.1000.TAR(1,1),-04+04.xls",sep = '\t')
dat.m02p04 <- read.table("freq.AR.TAR.1000.TAR(1,1),-02+04.xls",sep = '\t')
dat.p00p04 <- read.table("freq.AR.TAR.1000.TAR(1,1),+00+04.xls",sep = '\t')
dat.p02p04 <- read.table("freq.AR.TAR.1000.TAR(1,1),+02+04.xls",sep = '\t')
dat.p04p04 <- read.table("freq.AR.TAR.1000.TAR(1,1),+04+04.xls",sep = '\t')
dat.p06p04 <- read.table("freq.AR.TAR.1000.TAR(1,1),+06+04.xls",sep = '\t')
dat.p08p04 <- read.table("freq.AR.TAR.1000.TAR(1,1),+08+04.xls",sep = '\t')

dat.m08p06 <- read.table("freq.AR.TAR.1000.TAR(1,1),-08+06.xls",sep = '\t')
dat.m06p06 <- read.table("freq.AR.TAR.1000.TAR(1,1),-06+06.xls",sep = '\t')
dat.m04p06 <- read.table("freq.AR.TAR.1000.TAR(1,1),-04+06.xls",sep = '\t')
dat.m02p06 <- read.table("freq.AR.TAR.1000.TAR(1,1),-02+06.xls",sep = '\t')
dat.p00p06 <- read.table("freq.AR.TAR.1000.TAR(1,1),+00+06.xls",sep = '\t')
dat.p02p06 <- read.table("freq.AR.TAR.1000.TAR(1,1),+02+06.xls",sep = '\t')
dat.p04p06 <- read.table("freq.AR.TAR.1000.TAR(1,1),+04+06.xls",sep = '\t')
dat.p06p06 <- read.table("freq.AR.TAR.1000.TAR(1,1),+06+06.xls",sep = '\t')
dat.p08p06 <- read.table("freq.AR.TAR.1000.TAR(1,1),+08+06.xls",sep = '\t')

dat.m08p08 <- read.table("freq.AR.TAR.1000.TAR(1,1),-08+08.xls",sep = '\t')
dat.m06p08 <- read.table("freq.AR.TAR.1000.TAR(1,1),-06+08.xls",sep = '\t')
dat.m04p08 <- read.table("freq.AR.TAR.1000.TAR(1,1),-04+08.xls",sep = '\t')
dat.m02p08 <- read.table("freq.AR.TAR.1000.TAR(1,1),-02+08.xls",sep = '\t')
dat.p00p08 <- read.table("freq.AR.TAR.1000.TAR(1,1),+00+08.xls",sep = '\t')
dat.p02p08 <- read.table("freq.AR.TAR.1000.TAR(1,1),+02+08.xls",sep = '\t')
dat.p04p08 <- read.table("freq.AR.TAR.1000.TAR(1,1),+04+08.xls",sep = '\t')
dat.p06p08 <- read.table("freq.AR.TAR.1000.TAR(1,1),+06+08.xls",sep = '\t')
dat.p08p08 <- read.table("freq.AR.TAR.1000.TAR(1,1),+08+08.xls",sep = '\t')

# selection frequencies of TAR(1,1) (5th row)
tar.matrix <- rbind(
dat.m08m08[5,],dat.m06m08[5,],dat.m04m08[5,],dat.m02m08[5,],dat.p00m08[5,],dat.p02m08[5,],dat.p04m08[5,],dat.p06m08[5,],dat.p08m08[5,],
dat.m08m06[5,],dat.m06m06[5,],dat.m04m06[5,],dat.m02m06[5,],dat.p00m06[5,],dat.p02m06[5,],dat.p04m06[5,],dat.p06m06[5,],dat.p08m06[5,],
dat.m08m04[5,],dat.m06m04[5,],dat.m04m04[5,],dat.m02m04[5,],dat.p00m04[5,],dat.p02m04[5,],dat.p04m04[5,],dat.p06m04[5,],dat.p08m04[5,],
dat.m08m02[5,],dat.m06m02[5,],dat.m04m02[5,],dat.m02m02[5,],dat.p00m02[5,],dat.p02m02[5,],dat.p04m02[5,],dat.p06m02[5,],dat.p08m02[5,],
dat.m08p00[5,],dat.m06p00[5,],dat.m04p00[5,],dat.m02p00[5,],dat.p00p00[5,],dat.p02p00[5,],dat.p04p00[5,],dat.p06p00[5,],dat.p08p00[5,],
dat.m08p02[5,],dat.m06p02[5,],dat.m04p02[5,],dat.m02p02[5,],dat.p00p02[5,],dat.p02p02[5,],dat.p04p02[5,],dat.p06p02[5,],dat.p08p02[5,],
dat.m08p04[5,],dat.m06p04[5,],dat.m04p04[5,],dat.m02p04[5,],dat.p00p04[5,],dat.p02p04[5,],dat.p04p04[5,],dat.p06p04[5,],dat.p08p04[5,],
dat.m08p06[5,],dat.m06p06[5,],dat.m04p06[5,],dat.m02p06[5,],dat.p00p06[5,],dat.p02p06[5,],dat.p04p06[5,],dat.p06p06[5,],dat.p08p06[5,],
dat.m08p08[5,],dat.m06p08[5,],dat.m04p08[5,],dat.m02p08[5,],dat.p00p08[5,],dat.p02p08[5,],dat.p04p08[5,],dat.p06p08[5,],dat.p08p08[5,]
)

#selection frequencies of AR(1) (1st row)
ar.matrix <- rbind(
dat.m08m08[1,],dat.m06m08[1,],dat.m04m08[1,],dat.m02m08[1,],dat.p00m08[1,],dat.p02m08[1,],dat.p04m08[1,],dat.p06m08[1,],dat.p08m08[1,],
dat.m08m06[1,],dat.m06m06[1,],dat.m04m06[1,],dat.m02m06[1,],dat.p00m06[1,],dat.p02m06[1,],dat.p04m06[1,],dat.p06m06[1,],dat.p08m06[1,],
dat.m08m04[1,],dat.m06m04[1,],dat.m04m04[1,],dat.m02m04[1,],dat.p00m04[1,],dat.p02m04[1,],dat.p04m04[1,],dat.p06m04[1,],dat.p08m04[1,],
dat.m08m02[1,],dat.m06m02[1,],dat.m04m02[1,],dat.m02m02[1,],dat.p00m02[1,],dat.p02m02[1,],dat.p04m02[1,],dat.p06m02[1,],dat.p08m02[1,],
dat.m08p00[1,],dat.m06p00[1,],dat.m04p00[1,],dat.m02p00[1,],dat.p00p00[1,],dat.p02p00[1,],dat.p04p00[1,],dat.p06p00[1,],dat.p08p00[1,],
dat.m08p02[1,],dat.m06p02[1,],dat.m04p02[1,],dat.m02p02[1,],dat.p00p02[1,],dat.p02p02[1,],dat.p04p02[1,],dat.p06p02[1,],dat.p08p02[1,],
dat.m08p04[1,],dat.m06p04[1,],dat.m04p04[1,],dat.m02p04[1,],dat.p00p04[1,],dat.p02p04[1,],dat.p04p04[1,],dat.p06p04[1,],dat.p08p04[1,],
dat.m08p06[1,],dat.m06p06[1,],dat.m04p06[1,],dat.m02p06[1,],dat.p00p06[1,],dat.p02p06[1,],dat.p04p06[1,],dat.p06p06[1,],dat.p08p06[1,],
dat.m08p08[1,],dat.m06p08[1,],dat.m04p08[1,],dat.m02p08[1,],dat.p00p08[1,],dat.p02p08[1,],dat.p04p08[1,],dat.p06p08[1,],dat.p08p08[1,]
)


# select information criterion
#1: regime AIC, hat sigma, 2: regime AIC, tilde sigma
#3: regime SIC, hat sigma, 4: regime SIC, tilde sigma
#5: regime AICc, hat sigma,6: regime AICc, tilde sigma
#7: regime WIC, hat sigma, 8: regime WIC, tilde sigma
#  9 - 16: equally weighted information criteria
# 17 - 24: overall information criteria

### TAR ###

data.tar.AIC.eq.LS<- matrix(tar.matrix[,10],ncol=length(phi1),nrow=length(phi1))
colnames(data.tar.AIC.eq.LS)<-phi2
rownames(data.tar.AIC.eq.LS)<-phi1

data.tar.BIC.eq.LS<- matrix(tar.matrix[,12],ncol=length(phi1),nrow=length(phi1))
colnames(data.tar.BIC.eq.LS)<-phi2
rownames(data.tar.BIC.eq.LS)<-phi1


### AR ###

data.ar.AIC.eq.LS<- matrix(ar.matrix[,10],ncol=length(phi1),nrow=length(phi1))
colnames(data.ar.AIC.eq.LS)<-phi2
rownames(data.ar.AIC.eq.LS)<-phi1

data.ar.BIC.eq.LS<- matrix(ar.matrix[,12],ncol=length(phi1),nrow=length(phi1))
colnames(data.ar.BIC.eq.LS)<-phi2
rownames(data.ar.BIC.eq.LS)<-phi1


### Defining Colours ###

#blue and grey
uniblau <- rgb(red= 0, green= 80, blue= 155, maxColorValue= 255)
unigrau <- rgb(red= 153, green= 153, blue= 153, maxColorValue= 255)


### 3D Plots ###
# TAR


persp(phi1, phi2, data.tar.AIC.eq.LS, theta = -30, phi = 15, expand = 0.5, col = uniblau,
      ltheta = 100, shade = 0.5, ticktype = "detailed", 
      xlab="phi1", ylab = "phi2", zlab = "" , zlim=c(0,1),
      main="Selection Frequency AIC.eq.LS TAR(2;1,1)", sub="DGP: TAR(2;1,1) with n=1000")

windows()

persp(phi1, phi2, data.tar.BIC.eq.LS, theta = -30, phi = 15, expand = 0.5, col = uniblau,
      ltheta = 100, shade = 0.5, ticktype = "detailed", 
      xlab="phi1", ylab = "phi2", zlab = "" , zlim=c(0,1),
      main="Selection Frequency BIC.eq.LS TAR(2;1,1)", sub="DGP: TAR(2;1,1) with n=1000")


#AR


windows()

persp(phi1, phi2, data.ar.AIC.eq.LS, theta = -30, phi = 15, expand = 0.5, col = unigrau,
      ltheta = 100, shade = 0.5, ticktype = "detailed", 
      xlab="phi1", ylab = "phi2", zlab = "" , zlim=c(0,1),
      main="Selection Frequency AIC.eq.LS AR(1)", sub="DGP: TAR(2;1,1) with n=1000")
      
windows()

persp(phi1, phi2, data.ar.BIC.eq.LS, theta = -30, phi = 15, expand = 0.5, col = unigrau,
      ltheta = 100, shade = 0.5, ticktype = "detailed", 
      xlab="phi1", ylab = "phi2", zlab = "" ,zlim=c(0,1),
      main="Selection Frequency BIC.eq.LS AR(1)", sub="DGP: TAR(2;1,1) with n=1000")

